## golly 2.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

project( golly )

set( APP_VERSION 2.3 )

if(APPLE OR WIN32)
   # app names are usually capitalized on Mac OS X and Windows
   set( APP_NAME Golly )
else()
   # Linux binaries are usually all lowercase
   set( APP_NAME golly )
endif()

# low-level code used in all executables
set(BASE_SOURCES
   bigint.cpp generationsalgo.cpp ghashbase.cpp
   ghashdraw.cpp hlifealgo.cpp hlifedraw.cpp jvnalgo.cpp lifealgo.cpp
   lifepoll.cpp liferender.cpp liferules.cpp qlifealgo.cpp qlifedraw.cpp
   readpattern.cpp ruletable_algo.cpp ruletreealgo.cpp
   util.cpp viewport.cpp writepattern.cpp
   
   bigint.h generationsalgo.h ghashbase.h hlifealgo.h jvnalgo.h lifealgo.h
   lifepoll.h liferender.h liferules.h platform.h qlifealgo.h
   readpattern.h ruletable_algo.h ruletreealgo.h
   util.h viewport.h writepattern.h
)

# high-level GUI code used only in Golly
set(GUI_SOURCES
   wxalgos.cpp wxcontrol.cpp
   wxedit.cpp wxfile.cpp wxgolly.cpp wxhelp.cpp wxinfo.cpp wxlayer.cpp
   wxmain.cpp wxperl.cpp wxprefs.cpp wxpython.cpp wxrender.cpp wxrule.cpp
   wxscript.cpp wxselect.cpp wxstatus.cpp wxtimeline.cpp wxundo.cpp
   wxutils.cpp wxview.cpp
   
   wxalgos.h wxedit.h wxgolly.h wxhelp.h wxinfo.h wxlayer.h
   wxmain.h wxperl.h wxprefs.h wxpython.h wxrender.h wxrule.h wxscript.h
   wxselect.h wxstatus.h wxtimeline.h wxundo.h wxutils.h wxview.h
)

set(RESOURCES
   golly.rc
   appicon.ico appicon16.ico appicon32.ico appicon48.ico appicon.xpm
   Info.plist.in
   app.icns file-mc.icns file-rle.icns
)

if(APPLE)
   # on Mac OS X it's better to use locally installed wxWidgets headers and libs
   # (the pre-installed stuff tends to be out of date; eg. 10.6 has wxMac 2.8.8 and it's a 32-bit debug build)
   set( wxWidgets_CONFIG_EXECUTABLE /usr/local/bin/wx-config )
   set( wxWidgets_wxrc_EXECUTABLE /usr/local/bin/wxrc )         # not used, but no harm leaving it in
   
   # to avoid statically linking the Perl library into the app we do these 2 steps:
   # 1. override PERL_INCLUDE_PATH to simplified output from "/usr/bin/perl -MExtUtils::Embed -e ccopts"
   # 2. override PERL_LIBRARY to simplified output from "/usr/bin/perl -MExtUtils::Embed -e ldopts"
   set( PERL_INCLUDE_PATH /System/Library/Perl/5.10.0/darwin-thread-multi-2level/CORE )
   set( PERL_LIBRARY "-L/usr/local/lib -L/System/Library/Perl/5.10.0/darwin-thread-multi-2level/CORE -lperl -ldl -lm -lutil -lc" )
elseif(UNIX)
   # remove -rdynamic from link options on Linux to reduce golly size by about 1.2MB
   set( CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS "" )
endif()

find_package( wxWidgets REQUIRED html net adv core base )

if(WIN32)
   # use zlib library included in wxWidgets
   set( ZLIB_INCLUDE_DIR ${wxWidgets_ROOT_DIR}/src/zlib )
   set( ZLIB_LIBRARY ${wxWidgets_LIB_DIR}/wxzlib.lib )
   
   # PERL_LIBARY is not used in our Windows build but cmake needs a setting
   set( PERL_LIBRARY lib_not_used )
endif()

find_package( ZLIB REQUIRED )
find_package( PerlLibs REQUIRED )
find_package( PythonLibs REQUIRED )

include_directories( 
   ${ZLIB_INCLUDE_DIR}
   ${PERL_INCLUDE_PATH}
   ${PYTHON_INCLUDE_PATH}
)
include( ${wxWidgets_USE_FILE} )

# pass extra settings to the compiler
add_definitions(-DZLIB -DVERSION=${APP_VERSION})
if(APPLE)
   # support Mac OS 10.5 or later
   add_definitions(-mmacosx-version-min=10.5)
endif()
if(APPLE OR UNIX)
   # use same settings as in makefiles
   add_definitions(-D_LARGE_FILES -O5)
endif()

# put the executables in the src folder
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR})

# create base library used by all 3 executables
add_library( gollybase STATIC ${BASE_SOURCES} )

add_executable( ${APP_NAME}
   WIN32
   MACOSX_BUNDLE      # build a properly bundled Mac app
   ${GUI_SOURCES}
   ${RESOURCES} 
)

add_executable( bgolly
   bgolly.cpp
)

add_executable( RuleTableToTree
   RuleTableToTree.cpp 
)

if(APPLE OR WIN32)
   target_link_libraries( ${APP_NAME} gollybase ${wxWidgets_LIBRARIES} ${ZLIB_LIBRARIES} )
   target_link_libraries( bgolly gollybase ${ZLIB_LIBRARIES} )
   target_link_libraries( RuleTableToTree gollybase ${ZLIB_LIBRARIES} )
else()
   # on Linux we statically link zlib because some systems (eg. Ubuntu) have a non-standard zlib that contains gzopen64
   add_library( static_zlib STATIC IMPORTED )
   set_property( TARGET static_zlib PROPERTY IMPORTED_LOCATION /usr/lib/libz.a )
   target_link_libraries( ${APP_NAME} gollybase ${wxWidgets_LIBRARIES} static_zlib )
   target_link_libraries( bgolly gollybase static_zlib )
   target_link_libraries( RuleTableToTree gollybase static_zlib )
endif()

if(APPLE)
   # create Info.plist (using Info.plist.in) and PkgInfo files inside .app bundle
   add_custom_target( app_bundle
      COMMAND sed -e "s/VERSION/${APP_VERSION}/" ${CMAKE_SOURCE_DIR}/Info.plist.in >${CMAKE_SOURCE_DIR}/Golly.app/Contents/Info.plist
      COMMAND echo -n "APPLGoLy" >${CMAKE_SOURCE_DIR}/Golly.app/Contents/PkgInfo
   )
   add_dependencies( ${APP_NAME} app_bundle )
   
   # copy *.icns files into Resources directory inside .app bundle
   set_source_files_properties( ${CMAKE_SOURCE_DIR}/app.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources )
   set_source_files_properties( ${CMAKE_SOURCE_DIR}/file-mc.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources )
   set_source_files_properties( ${CMAKE_SOURCE_DIR}/file-rle.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources )
   
   # strip out debug info (reduces app size by 1.6MB)
   target_link_libraries( ${APP_NAME} -Wl,-dead_strip -Wl,-S )
   
   # only the Mac app needs to be linked against the Perl and Python libs
   # (on Windows and Linux those libs are dynamically loaded the first time a script is run)
   target_link_libraries( ${APP_NAME} ${PERL_LIBRARY} ${PYTHON_LIBRARIES} )
endif()

# hack to get around the "Debug" and "Release" folders Visual Studio adds on Windows
# http://stackoverflow.com/questions/543203/cmake-runtime-output-directory-on-windows
if(MSVC_IDE)
   set_target_properties( ${APP_NAME} bgolly RuleTableToTree PROPERTIES PREFIX "../" )
endif()

## golly 2.2

=== debian/changelog ===
golly (2.2-1) unstable; urgency=low

  * New upstream release (Closes: #605935).  Thanks to Benjamin Mako Hill.
    64-bit python binding fixed in upstream (Closes: #495941).
    Thanks to Paul Metcalfe.
    Installation has been improved in upstream (Closes: #588116, #598815).
    Thanks to Stefan Gursky and Mathijs Romans.
    Patches for bgolly, makefile-gtk (for perl), wxfile.cpp, wxgolly.cpp
    and wxUSE_HOTKEY things are not needed any more, thus removed.
  * debian/control (Build-Depends): Add autotools-dev and quilt.  Replace
    libstdc++6-4.3-dev to libstdc++6-4.4-dev (Closes: #594282).
    Thanks to Matthias Klose.
  * debian/rules: Now use dh.
  * debian/source/format: Now use 3.0 (quilt) format.
  * debian/golly.manpages: New.

 -- NIIBE Yutaka <gniibe@fsij.org>  Mon, 14 Feb 2011 17:45:27 +0900

golly (2.1-1) unstable; urgency=low

  * New upstream release (Closes: #495072).
  * debian/control: Added Build-Conflicts (Closes: #508947).
  * debian/rules: Remove dh_desktop which is deprecated.

 -- NIIBE Yutaka <gniibe@fsij.org>  Wed, 03 Feb 2010 15:51:42 +0900

golly (1.4-1) unstable; urgency=low

  * Fixed user preference file directory and clipfile directory, by using
  Newer wxwidget 2.8 (Closes: #488188).  Thanks to Jakob Lell for the bug
  report.
  * Revert changes of wxfile.cpp and wxprefs.cpp for wxwidget 2.6.
  * New upstream release (Changes of hlifealgo.cpp and qlifealgo.cpp
  are now in upstream).
  * platform.h: Added #include <limits.h>.
  * debian/control (Standards-Version): Conform to 3.8.0 (was: 3.7.3).
  (Build-Depends): Use libwxgtk2.8-dev (was: libwxgtk2.6-dev).
  Use libstdc++6-4.3-dev (was: libstdc++6-4.2-dev).

 -- NIIBE Yutaka <gniibe@fsij.org>  Mon, 07 Jul 2008 15:28:52 +0900

golly (1.3-5) unstable; urgency=low

  * bgolly.cpp, bigint.cpp, liferules.cpp: Added #include for GCC 4.3.
    Thanks to Lucas Nussbaum (Closes: #474803).

 -- NIIBE Yutaka <gniibe@fsij.org>  Tue, 08 Apr 2008 10:27:02 +0900

golly (1.3-4) unstable; urgency=low

  * debian/watch: Fix URL by Davide Cavalca (Closes: #472176).
  * debian/golly.desktop, debian/rules, debian/dirs: Desktop menu support
    contributed by Davide Cavalca (Closes: #472136).
  * makefile-gtk: Perl version free patch by Davide Cavalca
    applied. (Closes: #470393).  Thanks to Niko Tyni for the report.

 -- NIIBE Yutaka <gniibe@fsij.org>  Fri, 28 Mar 2008 11:36:24 +0900

golly (1.3-3) unstable; urgency=low

  * hlifealgo.cpp, qlifealgo.cpp: Patch for 64-bit architectures by Davide
    Cavalca applied. (Closes: #470160).

 -- NIIBE Yutaka <gniibe@fsij.org>  Mon, 10 Mar 2008 11:56:52 +0900

golly (1.3-2) unstable; urgency=low

  * debian/control (Build-Depends): Added zlib1g-dev and libstdc++6-4.2-dev.

 -- NIIBE Yutaka <gniibe@fsij.org>  Mon, 25 Feb 2008 23:09:36 +0900

golly (1.3-1) unstable; urgency=low

  * Initial release (Closes: #452026).

 -- NIIBE Yutaka <gniibe@fsij.org>  Thu, 31 Jan 2008 16:03:17 +0900

=== debian/control ===
Source: golly
Section: games
Priority: optional
Maintainer: NIIBE Yutaka <gniibe@fsij.org>
Build-Conflicts: libwxgtk2.6-dev
Build-Depends: debhelper (>= 7.0.50~), autotools-dev, quilt (>= 0.46-7~), libwxgtk2.8-dev, python, python-dev, perl, libperl-dev, libstdc++6-4.4-dev, zlib1g-dev
Standards-Version: 3.9.1
Homepage: http://golly.sourceforge.net/

Package: golly
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Game of Life simulator using hashlife algorithm
 Golly simulates Conway's Game of Life with an arbitrarily large grid
 of cells.  It can optionally use a hashlife algorithm, which allows
 it to rapidly compute generations for huge patterns, and to compute
 many generations into the future at a time.
 .
 Golly provides a graphical interface for viewing and editing cellular
 automata.  It supports copy and paste, zoom, auto-fit, multiple
 layers, and viewing different areas of a pattern simultaneously in
 different areas of a window.
 .
 Golly can load patterns from RLE, Life 1.05/1.06, dblife, and
 macrocell file formats; it can also interpret images as Life
 patterns.  Golly provides integrated help, including a copy of the
 Life Lexicon.
 .
 Golly also supports other rules for 2D cellular automata with an
 8-cell neighborhood, and supports 1D cellular automata.

## golly 2.3

=== debian/changelog ===
golly (2.3-1) unstable; urgency=low

  * New upstream release.
  * Fixed FTBFS (Closes: #652180).
  * debian/control (Build-Depends): Add python-support.
  (Standards-Version): conforms to 3.9.2.
  (Build-Depends): Updated to libstdc++6-4.6-dev (was 4.4).

 -- NIIBE Yutaka <gniibe@fsij.org>  Thu, 22 Dec 2011 15:55:35 +0900

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: optional
 Maintainer: NIIBE Yutaka <gniibe@fsij.org>
 Build-Conflicts: libwxgtk2.6-dev
-Build-Depends: debhelper (>= 7.0.50~), autotools-dev, quilt (>= 0.46-7~), libwxgtk2.8-dev, python, python-dev, perl, libperl-dev, libstdc++6-4.4-dev, zlib1g-dev
-Standards-Version: 3.9.1
+Build-Depends: debhelper (>= 7.0.50~), autotools-dev, quilt (>= 0.46-7~), libwxgtk2.8-dev, python, python-dev, perl, libperl-dev, libstdc++6-4.6-dev, zlib1g-dev, python-support (>= 0.90)
+Standards-Version: 3.9.2
 Homepage: http://golly.sourceforge.net/
 
 Package: golly

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

PERL_SHLIB=$(shell ls -l /usr/lib/libperl.so | sed 's/^.* -> \(.*\)$$/\1/')

%:
	dh $@ --with quilt

override_dh_auto_configure:
	dh_auto_configure -- --with-perl-shlib=$(PERL_SHLIB)

override_dh_auto_install:
	dh_auto_install
        # we have license information in /usr/share/doc/golly/copyright already
	rm $(CURDIR)/debian/golly/usr/share/doc/golly/LICENSE
        # golly should be in /usr/games, we should have icon and menu
	mkdir -p $(CURDIR)/debian/golly/usr/games \
	         $(CURDIR)/debian/golly/usr/share/pixmaps \
		 $(CURDIR)/debian/golly/usr/share/applications
	mv $(CURDIR)/debian/golly/usr/bin/golly $(CURDIR)/debian/golly/usr/games/golly
	install -m 444 appicon.xpm  $(CURDIR)/debian/golly/usr/share/pixmaps/golly.xpm
	install -m 444 debian/golly.desktop $(CURDIR)/debian/golly/usr/share/applications
        # Fix installation
	chmod +x $(CURDIR)/debian/golly/usr/share/golly/Help/Lexicon/modify.pl

## golly 2.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 project( golly )
 
-set( APP_VERSION 2.3 )
+set( APP_VERSION 2.4 )
 
 if(APPLE OR WIN32)
    # app names are usually capitalized on Mac OS X and Windows
@@ -87,12 +87,26 @@
 # pass extra settings to the compiler
 add_definitions(-DZLIB -DVERSION=${APP_VERSION})
 if(APPLE)
-   # support Mac OS 10.5 or later
-   add_definitions(-mmacosx-version-min=10.5)
+   # support Mac OS 10.6 or later
+   add_definitions(-mmacosx-version-min=10.6)
 endif()
 if(APPLE OR UNIX)
    # use same settings as in makefiles
    add_definitions(-D_LARGE_FILES -O5)
+endif()
+# workaround for wx2.9.3 wxAssert link errors, see http://trac.wxwidgets.org/ticket/12626
+SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -DwxDEBUG_LEVEL=0")
+# avoid security warnings
+if(MSVC)
+  add_definitions(/D_CRT_SECURE_NO_WARNINGS /D_CRT_NONSTDC_NO_WARNINGS)
+endif()
+
+# set this to true if using Visual Leak Detector to find memory leaks
+set(USING_VISUAL_LEAK_DETECTOR FALSE)
+if(USING_VISUAL_LEAK_DETECTOR)
+  set(VLD_INCLUDE_DIR "C:\Program Files\Visual Leak Detector\include")
+  set(VLD_LIBRARIES "C:\Program Files\Visual Leak Detector\lib\Win32\vld.lib")
+  add_definitions(/DUSING_VISUAL_LEAK_DETECTOR)
 endif()
 
 # put the executables in the src folder
@@ -155,3 +169,10 @@
 if(MSVC_IDE)
    set_target_properties( ${APP_NAME} bgolly RuleTableToTree PROPERTIES PREFIX "../" )
 endif()
+
+if(USING_VISUAL_LEAK_DETECTOR)
+   include_directories( ${VLD_INCLUDE_DIR} )
+   target_link_libraries( ${APP_NAME} ${VLD_LIBRARIES} )
+   target_link_libraries( bgolly ${VLD_LIBRARIES} )
+   target_link_libraries( RuleTableToTree ${VLD_LIBRARIES} )
+endif()

=== debian/changelog ===
golly (2.4-1) unstable; urgency=low

  * New upstream release.
  * debian/compat: Upgrade to 9.
  * debian/control (Depends): Add ${python:Depends}.
    (Build-Depents): Require debhelper >= 9.
  * debian/rules (DH_OPTIONS): Add.

 -- NIIBE Yutaka <gniibe@fsij.org>  Sat, 24 Nov 2012 12:27:17 +0900

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,13 @@
 Priority: optional
 Maintainer: NIIBE Yutaka <gniibe@fsij.org>
 Build-Conflicts: libwxgtk2.6-dev
-Build-Depends: debhelper (>= 7.0.50~), autotools-dev, quilt (>= 0.46-7~), libwxgtk2.8-dev, python, python-dev, perl, libperl-dev, libstdc++6-4.6-dev, zlib1g-dev, python-support (>= 0.90)
-Standards-Version: 3.9.2
+Build-Depends: debhelper (>= 9), autotools-dev, quilt (>= 0.46-7~), libwxgtk2.8-dev, python, python-dev, perl, libperl-dev, libstdc++6-4.6-dev, zlib1g-dev, python-support (>= 0.90)
+Standards-Version: 3.9.3
 Homepage: http://golly.sourceforge.net/
 
 Package: golly
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
 Description: Game of Life simulator using hashlife algorithm
  Golly simulates Conway's Game of Life with an arbitrarily large grid
  of cells.  It can optionally use a hashlife algorithm, which allows

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,7 @@
 # -*- makefile -*-
 
 PERL_SHLIB=$(shell ls -l /usr/lib/libperl.so | sed 's/^.* -> \(.*\)$$/\1/')
+export DH_OPTIONS
 
 %:
 	dh $@ --with quilt

## golly 2.5

=== gui-wx/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

project( golly )

set( APP_VERSION 2.5 )

if(APPLE OR WIN32)
   # app names are usually capitalized on Mac OS X and Windows
   set( APP_NAME Golly )
else()
   # Linux binaries are usually all lowercase
   set( APP_NAME golly )
endif()

# low-level code used in all executables
set(BASE_SOURCES
   ../gollybase/bigint.h            ../gollybase/bigint.cpp
   ../gollybase/generationsalgo.h   ../gollybase/generationsalgo.cpp
   ../gollybase/ghashbase.h         ../gollybase/ghashbase.cpp
                                    ../gollybase/ghashdraw.cpp
   ../gollybase/hlifealgo.h         ../gollybase/hlifealgo.cpp
                                    ../gollybase/hlifedraw.cpp
   ../gollybase/jvnalgo.h           ../gollybase/jvnalgo.cpp
   ../gollybase/lifealgo.h          ../gollybase/lifealgo.cpp
   ../gollybase/lifepoll.h          ../gollybase/lifepoll.cpp
   ../gollybase/liferender.h        ../gollybase/liferender.cpp
   ../gollybase/liferules.h         ../gollybase/liferules.cpp
   ../gollybase/platform.h
   ../gollybase/qlifealgo.h         ../gollybase/qlifealgo.cpp
                                    ../gollybase/qlifedraw.cpp
   ../gollybase/readpattern.h       ../gollybase/readpattern.cpp
   ../gollybase/ruleloaderalgo.h    ../gollybase/ruleloaderalgo.cpp
   ../gollybase/ruletable_algo.h    ../gollybase/ruletable_algo.cpp
   ../gollybase/ruletreealgo.h      ../gollybase/ruletreealgo.cpp
   ../gollybase/util.h              ../gollybase/util.cpp
   ../gollybase/viewport.h          ../gollybase/viewport.cpp
   ../gollybase/writepattern.h      ../gollybase/writepattern.cpp
)
include_directories( ../gollybase )

# high-level GUI code used in desktop Golly
set(GUI_SOURCES
   wxalgos.h        wxalgos.cpp
                    wxcontrol.cpp
   wxedit.h         wxedit.cpp
                    wxfile.cpp
   wxgolly.h        wxgolly.cpp
   wxhelp.h         wxhelp.cpp
   wxinfo.h         wxinfo.cpp
   wxlayer.h        wxlayer.cpp
   wxmain.h         wxmain.cpp
   wxperl.h         wxperl.cpp
   wxprefs.h        wxprefs.cpp
   wxpython.h       wxpython.cpp
   wxrender.h       wxrender.cpp
   wxrule.h         wxrule.cpp
   wxscript.h       wxscript.cpp
   wxselect.h       wxselect.cpp
   wxstatus.h       wxstatus.cpp
   wxtimeline.h     wxtimeline.cpp
   wxundo.h         wxundo.cpp
   wxutils.h        wxutils.cpp
   wxview.h         wxview.cpp
)

set(RESOURCES
   golly.rc
   Info.plist.in
   icons/appicon.ico icons/appicon16.ico icons/appicon32.ico icons/appicon48.ico icons/appicon.xpm
   icons/app.icns icons/file-mc.icns icons/file-rle.icns
)

if(APPLE)
   # on Mac OS X it's better to use locally installed wxWidgets headers and libs
   # (the pre-installed stuff tends to be out of date; eg. 10.6 has wxMac 2.8.8 and it's a 32-bit debug build)
   set( wxWidgets_CONFIG_EXECUTABLE /usr/local/bin/wx-config )
   set( wxWidgets_wxrc_EXECUTABLE /usr/local/bin/wxrc )         # not used, but no harm leaving it in
   
   # to avoid statically linking the Perl library into the app we do these 2 steps:
   # 1. override PERL_INCLUDE_PATH to simplified output from "/usr/bin/perl -MExtUtils::Embed -e ccopts"
   # 2. override PERL_LIBRARY to simplified output from "/usr/bin/perl -MExtUtils::Embed -e ldopts"
   set( PERL_INCLUDE_PATH /System/Library/Perl/5.10.0/darwin-thread-multi-2level/CORE )
   set( PERL_LIBRARY "-L/usr/local/lib -L/System/Library/Perl/5.10.0/darwin-thread-multi-2level/CORE -lperl -ldl -lm -lutil -lc" )
elseif(UNIX)
   # remove -rdynamic from link options on Linux to reduce golly size by about 1.2MB
   set( CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS "" )
endif()

find_package( wxWidgets REQUIRED html net adv core base )

if(WIN32)
   # use zlib library included in wxWidgets
   set( ZLIB_INCLUDE_DIR ${wxWidgets_ROOT_DIR}/src/zlib )
   set( ZLIB_LIBRARY ${wxWidgets_LIB_DIR}/wxzlib.lib )
   
   # PERL_LIBARY is not used in our Windows build but cmake needs a setting
   set( PERL_LIBRARY lib_not_used )
endif()

find_package( ZLIB REQUIRED )
find_package( PerlLibs REQUIRED )
find_package( PythonLibs REQUIRED )

include_directories( 
   ${ZLIB_INCLUDE_DIR}
   ${PERL_INCLUDE_PATH}
   ${PYTHON_INCLUDE_PATH}
)
include( ${wxWidgets_USE_FILE} )

# pass extra settings to the compiler
add_definitions(-DZLIB -DVERSION=${APP_VERSION})
if(APPLE)
   # support Mac OS 10.6 or later
   add_definitions(-mmacosx-version-min=10.6)
endif()
if(APPLE OR UNIX)
   # use same settings as in makefiles
   add_definitions(-D_LARGE_FILES -O5)
endif()
# workaround for wx2.9.3 wxAssert link errors, see http://trac.wxwidgets.org/ticket/12626
SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -DwxDEBUG_LEVEL=0")
# avoid security warnings
if(MSVC)
  add_definitions(/D_CRT_SECURE_NO_WARNINGS /D_CRT_NONSTDC_NO_WARNINGS)
endif()

# set this to true if using Visual Leak Detector to find memory leaks
set(USING_VISUAL_LEAK_DETECTOR FALSE)
if(USING_VISUAL_LEAK_DETECTOR)
  set(VLD_INCLUDE_DIR "C:\Program Files\Visual Leak Detector\include")
  set(VLD_LIBRARIES "C:\Program Files\Visual Leak Detector\lib\Win32\vld.lib")
  add_definitions(/DUSING_VISUAL_LEAK_DETECTOR)
endif()

# put the executables in parent directory
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/..)

# create base library used by all 3 executables
add_library( gollybase STATIC ${BASE_SOURCES} )

add_executable( ${APP_NAME}
   WIN32
   MACOSX_BUNDLE      # build a properly bundled Mac app
   ${GUI_SOURCES}
   ${RESOURCES} 
)

add_executable( bgolly
   ../cmdline/bgolly.cpp
)

target_link_libraries( ${APP_NAME} gollybase ${wxWidgets_LIBRARIES} ${ZLIB_LIBRARIES} )
target_link_libraries( bgolly gollybase ${ZLIB_LIBRARIES} )

if(APPLE)
   # create Info.plist (using Info.plist.in) and PkgInfo files inside .app bundle
   add_custom_target( app_bundle
      COMMAND sed -e "s/VERSION/${APP_VERSION}/" ${CMAKE_SOURCE_DIR}/Info.plist.in >${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/Golly.app/Contents/Info.plist
      COMMAND echo -n "APPLGoLy" >${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/Golly.app/Contents/PkgInfo
   )
   add_dependencies( ${APP_NAME} app_bundle )
   
   # copy *.icns files into Resources directory inside .app bundle
   set_source_files_properties( ${CMAKE_SOURCE_DIR}/icons/app.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources )
   set_source_files_properties( ${CMAKE_SOURCE_DIR}/icons/file-mc.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources )
   set_source_files_properties( ${CMAKE_SOURCE_DIR}/icons/file-rle.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources )
   
   # strip out debug info (reduces app size by 1.6MB)
   target_link_libraries( ${APP_NAME} -Wl,-dead_strip -Wl,-S )
   
   # only the Mac app needs to be linked against the Perl and Python libs
   # (on Windows and Linux those libs are dynamically loaded the first time a script is run)
   target_link_libraries( ${APP_NAME} ${PERL_LIBRARY} ${PYTHON_LIBRARIES} )
endif()

# hack to get around the "Debug" and "Release" folders Visual Studio adds on Windows
# http://stackoverflow.com/questions/543203/cmake-runtime-output-directory-on-windows
if(MSVC_IDE)
   set_target_properties( ${APP_NAME} bgolly PROPERTIES PREFIX "../" )
endif()

if(USING_VISUAL_LEAK_DETECTOR)
   include_directories( ${VLD_INCLUDE_DIR} )
   target_link_libraries( ${APP_NAME} ${VLD_LIBRARIES} )
   target_link_libraries( bgolly ${VLD_LIBRARIES} )
endif()

=== debian/changelog ===
golly (2.5-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * debian/control (Build-Depends): libwxgtk2.8-dev -> libwxgtk3.0-dev.

 -- Olly Betts <olly@survex.com>  Fri, 15 Nov 2013 15:34:28 +0000

golly (2.5-1) unstable; urgency=low

  * New upstream release.
  * debian/rules: Add --with python2.
  * debian/control (Build-Depends): Require libstdc++6-4.7-dev.
  (Standards-Version): conforms to 3.9.4.

 -- NIIBE Yutaka <gniibe@fsij.org>  Tue, 02 Jul 2013 06:46:02 +0000

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: optional
 Maintainer: NIIBE Yutaka <gniibe@fsij.org>
 Build-Conflicts: libwxgtk2.6-dev
-Build-Depends: debhelper (>= 9), autotools-dev, quilt (>= 0.46-7~), libwxgtk2.8-dev, python, python-dev, perl, libperl-dev, libstdc++6-4.6-dev, zlib1g-dev, python-support (>= 0.90)
-Standards-Version: 3.9.3
+Build-Depends: debhelper (>= 9), autotools-dev, quilt (>= 0.46-7~), libwxgtk3.0-dev, python, python-dev, perl, libperl-dev, libstdc++6-4.7-dev, zlib1g-dev, python-support (>= 0.90)
+Standards-Version: 3.9.4
 Homepage: http://golly.sourceforge.net/
 
 Package: golly

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

PERL_SHLIB=$(shell ls -l /usr/lib/libperl.so | sed 's/^.* -> \(.*\)$$/\1/')
export DH_OPTIONS

%:
	dh $@ --with quilt,python2 --builddirectory=build \
	      --sourcedirectory=gui-wx/configure

override_dh_auto_configure:
	dh_auto_configure -O--builddirectory=build \
	   -O--sourcedirectory=gui-wx/configure -- \
	   --with-perl-shlib=$(PERL_SHLIB)

override_dh_auto_install:
	dh_auto_install -O--builddirectory=build \
	   -O--sourcedirectory=gui-wx/configure
        # we have license information in /usr/share/doc/golly/copyright already
        # rm -f $(CURDIR)/debian/golly/usr/share/doc/golly/License.html
        # golly should be in /usr/games, we should have icon and menu
	mkdir -p $(CURDIR)/debian/golly/usr/games \
	         $(CURDIR)/debian/golly/usr/share/pixmaps \
		 $(CURDIR)/debian/golly/usr/share/applications
	mv $(CURDIR)/debian/golly/usr/bin/golly $(CURDIR)/debian/golly/usr/games/golly
	install -m 444 gui-wx/icons/appicon.xpm  $(CURDIR)/debian/golly/usr/share/pixmaps/golly.xpm
	install -m 444 debian/golly.desktop $(CURDIR)/debian/golly/usr/share/applications
        # Fix installation
	chmod +x $(CURDIR)/debian/golly/usr/share/golly/Help/Lexicon/modify.pl

=== debian/watch ===
version=3
http://sf.net/golly/golly-(.*)-src\.tar\.gz

## golly 2.6

=== gui-wx/CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 project( golly )
 
-set( APP_VERSION 2.5 )
+set( APP_VERSION 2.6 )
 
 if(APPLE OR WIN32)
    # app names are usually capitalized on Mac OS X and Windows

=== debian/changelog ===
golly (2.6-2) unstable; urgency=low

  * debian/rules (PERL_SHLIB): Add TRIPLET for libperl.so.  Patch from
    Niko Tyni.  Also, Thanks to Lucas Nussbaum.  (Closes: #759891).

  * debian/control (Build-Depends): Remove python-support.  Add dh-python.

 -- NIIBE Yutaka <gniibe@fsij.org>  Sun, 31 Aug 2014 18:40:47 +0000

golly (2.6-1) unstable; urgency=low

  * New upstream release.
  * debian/control (Standards-Version): conforms to 3.9.5.
    (Build-Depends): Remove libstdc++6-4.7-dev (Closes: 748001).
  * Incorporate NMU by Olly Betts (Closes: 729677).

 -- NIIBE Yutaka <gniibe@fsij.org>  Tue, 27 May 2014 12:18:32 +0000

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: optional
 Maintainer: NIIBE Yutaka <gniibe@fsij.org>
 Build-Conflicts: libwxgtk2.6-dev
-Build-Depends: debhelper (>= 9), autotools-dev, quilt (>= 0.46-7~), libwxgtk3.0-dev, python, python-dev, perl, libperl-dev, libstdc++6-4.7-dev, zlib1g-dev, python-support (>= 0.90)
-Standards-Version: 3.9.4
+Build-Depends: debhelper (>= 9), autotools-dev, quilt (>= 0.46-7~), libwxgtk3.0-dev, python, python-dev, perl, libperl-dev, zlib1g-dev, dh-python
+Standards-Version: 3.9.5
 Homepage: http://golly.sourceforge.net/
 
 Package: golly

## golly 2.7

=== gui-wx/CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 project( golly )
 
-set( APP_VERSION 2.6 )
+set( APP_VERSION 2.7 )
 
 if(APPLE OR WIN32)
    # app names are usually capitalized on Mac OS X and Windows
@@ -185,3 +185,9 @@
    target_link_libraries( ${APP_NAME} ${VLD_LIBRARIES} )
    target_link_libraries( bgolly ${VLD_LIBRARIES} )
 endif()
+
+# ensure we link the C runtime statically (N.B. still appears as /MD in the CMake gui but ignore this)
+# see: http://www.cmake.org/Wiki/CMake_FAQ#Dynamic_Replace
+foreach( var CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO )
+  string( REGEX REPLACE "/MD" "/MT" ${var} "${${var}}" )
+endforeach()

=== debian/changelog ===
golly (2.7-1) unstable; urgency=low

  * New upstream.
  * debian/control (Standards-Version): conforms to 3.9.6.

 -- NIIBE Yutaka <gniibe@fsij.org>  Sat, 19 Dec 2015 07:42:40 +0000

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: NIIBE Yutaka <gniibe@fsij.org>
 Build-Conflicts: libwxgtk2.6-dev
 Build-Depends: debhelper (>= 9), autotools-dev, quilt (>= 0.46-7~), libwxgtk3.0-dev, python, python-dev, perl, libperl-dev, zlib1g-dev, dh-python
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: http://golly.sourceforge.net/
 
 Package: golly

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,8 @@
 #!/usr/bin/make -f
 # -*- makefile -*-
 
-PERL_SHLIB=$(shell ls -l /usr/lib/libperl.so | sed 's/^.* -> \(.*\)$$/\1/')
+TRIPLET=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+PERL_SHLIB=$(shell ls -l /usr/lib/$(TRIPLET)/libperl.so | sed 's/^.* -> \(.*\)$$/\1/')
 export DH_OPTIONS
 
 %:

## golly 2.8

=== gui-web/Makefile ===
# Makefile for creating web app version of Golly using Emscripten.
# Type "emmake make" to build golly.html and golly.js.

SOURCES = main.cpp webcalls.cpp \
    ../gollybase/bigint.cpp \
    ../gollybase/generationsalgo.cpp \
    ../gollybase/ghashbase.cpp \
    ../gollybase/ghashdraw.cpp \
    ../gollybase/hlifealgo.cpp \
    ../gollybase/hlifedraw.cpp \
    ../gollybase/jvnalgo.cpp \
    ../gollybase/lifealgo.cpp \
    ../gollybase/lifepoll.cpp \
    ../gollybase/liferender.cpp \
    ../gollybase/liferules.cpp \
    ../gollybase/qlifealgo.cpp \
    ../gollybase/qlifedraw.cpp \
    ../gollybase/readpattern.cpp \
    ../gollybase/ruleloaderalgo.cpp \
    ../gollybase/ruletable_algo.cpp \
    ../gollybase/ruletreealgo.cpp \
    ../gollybase/util.cpp \
    ../gollybase/viewport.cpp \
    ../gollybase/writepattern.cpp \
    ../gui-common/algos.cpp \
    ../gui-common/control.cpp \
    ../gui-common/file.cpp \
    ../gui-common/layer.cpp \
    ../gui-common/prefs.cpp \
    ../gui-common/render.cpp \
    ../gui-common/select.cpp \
    ../gui-common/status.cpp \
    ../gui-common/undo.cpp \
    ../gui-common/utils.cpp \
    ../gui-common/view.cpp \
    ../gui-common/MiniZip/ioapi.c \
    ../gui-common/MiniZip/unzip.c \
    ../gui-common/MiniZip/zip.c \
    zlib/adler32.c \
    zlib/compress.c \
    zlib/crc32.c \
    zlib/deflate.c \
    zlib/gzclose.c \
    zlib/gzlib.c \
    zlib/gzread.c \
    zlib/gzwrite.c \
    zlib/infback.c \
    zlib/inffast.c \
    zlib/inflate.c \
    zlib/inftrees.c \
    zlib/trees.c \
    zlib/uncompr.c \
    zlib/zutil.c

OBJECTS = main.o webcalls.o \
    ../gollybase/bigint.o \
    ../gollybase/generationsalgo.o \
    ../gollybase/ghashbase.o \
    ../gollybase/ghashdraw.o \
    ../gollybase/hlifealgo.o \
    ../gollybase/hlifedraw.o \
    ../gollybase/jvnalgo.o \
    ../gollybase/lifealgo.o \
    ../gollybase/lifepoll.o \
    ../gollybase/liferender.o \
    ../gollybase/liferules.o \
    ../gollybase/qlifealgo.o \
    ../gollybase/qlifedraw.o \
    ../gollybase/readpattern.o \
    ../gollybase/ruleloaderalgo.o \
    ../gollybase/ruletable_algo.o \
    ../gollybase/ruletreealgo.o \
    ../gollybase/util.o \
    ../gollybase/viewport.o \
    ../gollybase/writepattern.o \
    ../gui-common/algos.o \
    ../gui-common/control.o \
    ../gui-common/file.o \
    ../gui-common/layer.o \
    ../gui-common/prefs.o \
    ../gui-common/render.o \
    ../gui-common/select.o \
    ../gui-common/status.o \
    ../gui-common/undo.o \
    ../gui-common/utils.o \
    ../gui-common/view.o \
    ../gui-common/MiniZip/ioapi.o \
    ../gui-common/MiniZip/unzip.o \
    ../gui-common/MiniZip/zip.o \
    zlib/adler32.o \
    zlib/compress.o \
    zlib/crc32.o \
    zlib/deflate.o \
    zlib/gzclose.o \
    zlib/gzlib.o \
    zlib/gzread.o \
    zlib/gzwrite.o \
    zlib/infback.o \
    zlib/inffast.o \
    zlib/inflate.o \
    zlib/inftrees.o \
    zlib/trees.o \
    zlib/uncompr.o \
    zlib/zutil.o

CFLAGS = -Izlib -Wall -Wextra -Wno-unused-parameter -Wno-implicit-function-declaration -O2

CXXFLAGS = -Izlib -I. -I../gollybase -I../gui-common -I../gui-common/MiniZip \
    -DVERSION=0.8 -DZLIB -DWEB_GUI -Wall -Wextra -Wno-unused-parameter -O2

# note that using -O2 results in a much smaller golly.js and no .map file

TARGET = golly.html

all: $(TARGET)

$(TARGET): $(OBJECTS) jslib.js shell.html
	$(CXX) $(CXXFLAGS) --js-library jslib.js --shell-file shell.html \
    --preload-file ../Patterns@/Patterns \
    --preload-file ../Rules@/Rules \
    --preload-file Help \
    --preload-file ../gui-common/Help/intro.html@/Help/intro.html \
    --preload-file ../gui-common/Help/tips.html@/Help/tips.html \
    --preload-file ../gui-common/Help/archives.html@/Help/archives.html \
    --preload-file ../gui-common/Help/refs.html@/Help/refs.html \
    --preload-file ../gui-common/Help/formats.html@/Help/formats.html \
    --preload-file ../gui-common/Help/bounded.html@/Help/bounded.html \
    --preload-file ../gui-common/Help/credits.html@/Help/credits.html \
    --preload-file ../gui-common/Help/algos.html@/Help/algos.html \
    --preload-file ../gui-common/Help/Algorithms@/Help/Algorithms \
    --preload-file ../gui-common/Help/Lexicon@/Help/Lexicon \
    -s TOTAL_MEMORY=300000000 \
    -s EXPORTED_FUNCTIONS="[ '_ClearStatus', '_NewUniverse', '_ResizeCanvas', \
    '_SetViewport', '_StartStop', '_Next', '_Step', '_GoSlower', '_GoFaster', '_StepBy1', \
    '_Undo', '_Redo', '_Fit', '_ZoomOut', '_ZoomIn', '_Scale1to1', '_Reset', \
    '_ToggleIcons', '_ModeChanged', '_StateChanged', '_DoMenuItem', '_UpdateMenuItems', \
    '_Paste', '_PasteAction', '_SelectionAction', '_OpenClickedFile', '_OpenClipboard', \
    '_ToggleAutoFit', '_OverCanvas', '_OnKeyChanged', '_OnMouseWheel', '_Info', '_CloseInfo', \
    '_Help', '_DoHelpClick', '_HelpBack', '_HelpNext', '_HelpContents', '_CloseHelp', \
    '_FileCreated', '_CancelProgress', '_CancelOpen', '_SaveFile', '_CancelSave', \
    '_StorePrefs', '_CancelPrefs', '_SaveLocalPrefs', '_FullScreen', '_ExitFullScreen', \
    '_UnsavedChanges' ]" \
    -o $@ $(LDFLAGS) $(OBJECTS)

# better to use -s ALLOW_MEMORY_GROWTH=1 instead of setting TOTAL_MEMORY???

clean:
	$(RM) $(OBJECTS) $(TARGET) golly.js golly.data

depend:
	@$(CXX) $(CXXFLAGS) -MM $(SOURCES)

# type "emmake make depend" to generate these dependencies:

main.o: main.cpp ../gollybase/bigint.h ../gollybase/lifealgo.h \
  ../gollybase/viewport.h ../gollybase/liferender.h \
  ../gollybase/lifepoll.h ../gollybase/readpattern.h \
  ../gollybase/platform.h ../gollybase/qlifealgo.h \
  ../gollybase/liferules.h ../gollybase/hlifealgo.h \
  ../gollybase/jvnalgo.h ../gollybase/ghashbase.h \
  ../gollybase/generationsalgo.h ../gollybase/ruleloaderalgo.h \
  ../gollybase/ruletable_algo.h ../gollybase/ruletreealgo.h \
  ../gui-common/algos.h ../gui-common/utils.h ../gui-common/prefs.h \
  ../gui-common/layer.h ../gui-common/select.h ../gui-common/control.h \
  ../gui-common/file.h ../gollybase/writepattern.h ../gui-common/view.h \
  ../gui-common/status.h ../gui-common/undo.h ../gui-common/render.h \
  webcalls.h
webcalls.o: webcalls.cpp ../gollybase/util.h ../gui-common/utils.h \
  ../gui-common/algos.h ../gollybase/lifealgo.h ../gollybase/bigint.h \
  ../gollybase/viewport.h ../gollybase/liferender.h \
  ../gollybase/lifepoll.h ../gollybase/readpattern.h \
  ../gollybase/platform.h ../gui-common/prefs.h ../gui-common/layer.h \
  ../gui-common/select.h ../gui-common/control.h ../gui-common/file.h \
  ../gollybase/writepattern.h ../gui-common/view.h \
  ../gui-common/status.h ../gui-common/undo.h webcalls.h
bigint.o: ../gollybase/bigint.cpp ../gollybase/bigint.h \
  ../gollybase/util.h
generationsalgo.o: ../gollybase/generationsalgo.cpp \
  ../gollybase/generationsalgo.h ../gollybase/ghashbase.h \
  ../gollybase/lifealgo.h ../gollybase/bigint.h ../gollybase/viewport.h \
  ../gollybase/liferender.h ../gollybase/lifepoll.h \
  ../gollybase/readpattern.h ../gollybase/platform.h \
  ../gollybase/liferules.h
ghashbase.o: ../gollybase/ghashbase.cpp ../gollybase/ghashbase.h \
  ../gollybase/lifealgo.h ../gollybase/bigint.h ../gollybase/viewport.h \
  ../gollybase/liferender.h ../gollybase/lifepoll.h \
  ../gollybase/readpattern.h ../gollybase/platform.h \
  ../gollybase/liferules.h ../gollybase/util.h
ghashdraw.o: ../gollybase/ghashdraw.cpp ../gollybase/ghashbase.h \
  ../gollybase/lifealgo.h ../gollybase/bigint.h ../gollybase/viewport.h \
  ../gollybase/liferender.h ../gollybase/lifepoll.h \
  ../gollybase/readpattern.h ../gollybase/platform.h \
  ../gollybase/liferules.h ../gollybase/util.h
hlifealgo.o: ../gollybase/hlifealgo.cpp ../gollybase/hlifealgo.h \
  ../gollybase/lifealgo.h ../gollybase/bigint.h ../gollybase/viewport.h \
  ../gollybase/liferender.h ../gollybase/lifepoll.h \
  ../gollybase/readpattern.h ../gollybase/platform.h \
  ../gollybase/liferules.h ../gollybase/util.h
hlifedraw.o: ../gollybase/hlifedraw.cpp ../gollybase/hlifealgo.h \
  ../gollybase/lifealgo.h ../gollybase/bigint.h ../gollybase/viewport.h \
  ../gollybase/liferender.h ../gollybase/lifepoll.h \
  ../gollybase/readpattern.h ../gollybase/platform.h \
  ../gollybase/liferules.h
jvnalgo.o: ../gollybase/jvnalgo.cpp ../gollybase/jvnalgo.h \
  ../gollybase/ghashbase.h ../gollybase/lifealgo.h ../gollybase/bigint.h \
  ../gollybase/viewport.h ../gollybase/liferender.h \
  ../gollybase/lifepoll.h ../gollybase/readpattern.h \
  ../gollybase/platform.h ../gollybase/liferules.h
lifealgo.o: ../gollybase/lifealgo.cpp ../gollybase/lifealgo.h \
  ../gollybase/bigint.h ../gollybase/viewport.h \
  ../gollybase/liferender.h ../gollybase/lifepoll.h \
  ../gollybase/readpattern.h ../gollybase/platform.h
lifepoll.o: ../gollybase/lifepoll.cpp ../gollybase/lifepoll.h \
  ../gollybase/util.h
liferender.o: ../gollybase/liferender.cpp ../gollybase/liferender.h
liferules.o: ../gollybase/liferules.cpp ../gollybase/liferules.h \
  ../gollybase/lifealgo.h ../gollybase/bigint.h ../gollybase/viewport.h \
  ../gollybase/liferender.h ../gollybase/lifepoll.h \
  ../gollybase/readpattern.h ../gollybase/platform.h ../gollybase/util.h
qlifealgo.o: ../gollybase/qlifealgo.cpp ../gollybase/qlifealgo.h \
  ../gollybase/lifealgo.h ../gollybase/bigint.h ../gollybase/viewport.h \
  ../gollybase/liferender.h ../gollybase/lifepoll.h \
  ../gollybase/readpattern.h ../gollybase/platform.h \
  ../gollybase/liferules.h ../gollybase/util.h
qlifedraw.o: ../gollybase/qlifedraw.cpp ../gollybase/qlifealgo.h \
  ../gollybase/lifealgo.h ../gollybase/bigint.h ../gollybase/viewport.h \
  ../gollybase/liferender.h ../gollybase/lifepoll.h \
  ../gollybase/readpattern.h ../gollybase/platform.h \
  ../gollybase/liferules.h ../gollybase/util.h
readpattern.o: ../gollybase/readpattern.cpp ../gollybase/readpattern.h \
  ../gollybase/bigint.h ../gollybase/lifealgo.h ../gollybase/viewport.h \
  ../gollybase/liferender.h ../gollybase/lifepoll.h \
  ../gollybase/platform.h ../gollybase/liferules.h ../gollybase/util.h \
  zlib/zlib.h zlib/zconf.h
ruleloaderalgo.o: ../gollybase/ruleloaderalgo.cpp \
  ../gollybase/ruleloaderalgo.h ../gollybase/ghashbase.h \
  ../gollybase/lifealgo.h ../gollybase/bigint.h ../gollybase/viewport.h \
  ../gollybase/liferender.h ../gollybase/lifepoll.h \
  ../gollybase/readpattern.h ../gollybase/platform.h \
  ../gollybase/liferules.h ../gollybase/ruletable_algo.h \
  ../gollybase/ruletreealgo.h ../gollybase/util.h
ruletable_algo.o: ../gollybase/ruletable_algo.cpp \
  ../gollybase/ruletable_algo.h ../gollybase/ghashbase.h \
  ../gollybase/lifealgo.h ../gollybase/bigint.h ../gollybase/viewport.h \
  ../gollybase/liferender.h ../gollybase/lifepoll.h \
  ../gollybase/readpattern.h ../gollybase/platform.h \
  ../gollybase/liferules.h ../gollybase/util.h
ruletreealgo.o: ../gollybase/ruletreealgo.cpp ../gollybase/ruletreealgo.h \
  ../gollybase/ghashbase.h ../gollybase/lifealgo.h ../gollybase/bigint.h \
  ../gollybase/viewport.h ../gollybase/liferender.h \
  ../gollybase/lifepoll.h ../gollybase/readpattern.h \
  ../gollybase/platform.h ../gollybase/liferules.h ../gollybase/util.h
util.o: ../gollybase/util.cpp ../gollybase/util.h
viewport.o: ../gollybase/viewport.cpp ../gollybase/viewport.h \
  ../gollybase/bigint.h ../gollybase/lifealgo.h \
  ../gollybase/liferender.h ../gollybase/lifepoll.h \
  ../gollybase/readpattern.h ../gollybase/platform.h
writepattern.o: ../gollybase/writepattern.cpp ../gollybase/writepattern.h \
  ../gollybase/lifealgo.h ../gollybase/bigint.h ../gollybase/viewport.h \
  ../gollybase/liferender.h ../gollybase/lifepoll.h \
  ../gollybase/readpattern.h ../gollybase/platform.h ../gollybase/util.h \
  zlib/zlib.h zlib/zconf.h
algos.o: ../gui-common/algos.cpp ../gollybase/bigint.h \
  ../gollybase/lifealgo.h ../gollybase/viewport.h \
  ../gollybase/liferender.h ../gollybase/lifepoll.h \
  ../gollybase/readpattern.h ../gollybase/platform.h \
  ../gollybase/qlifealgo.h ../gollybase/liferules.h \
  ../gollybase/hlifealgo.h ../gollybase/jvnalgo.h \

=== lua/Makefile ===
# A simplified Makefile for building the Lua library on Mac OS X or Linux.

LUA_LIB = liblua.a
CC = cc

PLATFORM = $(shell uname)
ifeq "$(PLATFORM)" "Darwin"
CFLAGS = -O2 -Wall -Wextra -DLUA_COMPAT_5_2 -DLUA_USE_MACOSX -arch x86_64
else
CFLAGS = -O2 -Wall -Wextra -DLUA_COMPAT_5_2 -DLUA_USE_LINUX
endif

OBJ_FILES = lapi.o lcode.o lctype.o ldebug.o ldo.o ldump.o lfunc.o lgc.o llex.o \
 lmem.o lobject.o lopcodes.o lparser.o lstate.o lstring.o ltable.o \
 ltm.o lundump.o lvm.o lzio.o \
 lauxlib.o lbaselib.o lbitlib.o lcorolib.o ldblib.o liolib.o \
 lmathlib.o loslib.o lstrlib.o ltablib.o lutf8lib.o loadlib.o linit.o

all: $(LUA_LIB)

$(LUA_LIB): $(OBJ_FILES)
	ar rcu $@ $(OBJ_FILES)
	ranlib $@

clean:
	rm -f $(LUA_LIB) $(OBJ_FILES)

depend:
	@$(CC) $(CFLAGS) -MM l*.c

lapi.o: lapi.c lprefix.h lua.h luaconf.h lapi.h llimits.h lstate.h \
 lobject.h ltm.h lzio.h lmem.h ldebug.h ldo.h lfunc.h lgc.h lstring.h \
 ltable.h lundump.h lvm.h
lauxlib.o: lauxlib.c lprefix.h lua.h luaconf.h lauxlib.h
lbaselib.o: lbaselib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
lbitlib.o: lbitlib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
lcode.o: lcode.c lprefix.h lua.h luaconf.h lcode.h llex.h lobject.h \
 llimits.h lzio.h lmem.h lopcodes.h lparser.h ldebug.h lstate.h ltm.h \
 ldo.h lgc.h lstring.h ltable.h lvm.h
lcorolib.o: lcorolib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
lctype.o: lctype.c lprefix.h lctype.h lua.h luaconf.h llimits.h
ldblib.o: ldblib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
ldebug.o: ldebug.c lprefix.h lua.h luaconf.h lapi.h llimits.h lstate.h \
 lobject.h ltm.h lzio.h lmem.h lcode.h llex.h lopcodes.h lparser.h \
 ldebug.h ldo.h lfunc.h lstring.h lgc.h ltable.h lvm.h
ldo.o: ldo.c lprefix.h lua.h luaconf.h lapi.h llimits.h lstate.h \
 lobject.h ltm.h lzio.h lmem.h ldebug.h ldo.h lfunc.h lgc.h lopcodes.h \
 lparser.h lstring.h ltable.h lundump.h lvm.h
ldump.o: ldump.c lprefix.h lua.h luaconf.h lobject.h llimits.h lstate.h \
 ltm.h lzio.h lmem.h lundump.h
lfunc.o: lfunc.c lprefix.h lua.h luaconf.h lfunc.h lobject.h llimits.h \
 lgc.h lstate.h ltm.h lzio.h lmem.h
lgc.o: lgc.c lprefix.h lua.h luaconf.h ldebug.h lstate.h lobject.h \
 llimits.h ltm.h lzio.h lmem.h ldo.h lfunc.h lgc.h lstring.h ltable.h
linit.o: linit.c lprefix.h lua.h luaconf.h lualib.h lauxlib.h
liolib.o: liolib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
llex.o: llex.c lprefix.h lua.h luaconf.h lctype.h llimits.h ldebug.h \
 lstate.h lobject.h ltm.h lzio.h lmem.h ldo.h lgc.h llex.h lparser.h \
 lstring.h ltable.h
lmathlib.o: lmathlib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
lmem.o: lmem.c lprefix.h lua.h luaconf.h ldebug.h lstate.h lobject.h \
 llimits.h ltm.h lzio.h lmem.h ldo.h lgc.h
loadlib.o: loadlib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
lobject.o: lobject.c lprefix.h lua.h luaconf.h lctype.h llimits.h \
 ldebug.h lstate.h lobject.h ltm.h lzio.h lmem.h ldo.h lstring.h lgc.h \
 lvm.h
lopcodes.o: lopcodes.c lprefix.h lopcodes.h llimits.h lua.h luaconf.h
loslib.o: loslib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
lparser.o: lparser.c lprefix.h lua.h luaconf.h lcode.h llex.h lobject.h \
 llimits.h lzio.h lmem.h lopcodes.h lparser.h ldebug.h lstate.h ltm.h \
 ldo.h lfunc.h lstring.h lgc.h ltable.h
lstate.o: lstate.c lprefix.h lua.h luaconf.h lapi.h llimits.h lstate.h \
 lobject.h ltm.h lzio.h lmem.h ldebug.h ldo.h lfunc.h lgc.h llex.h \
 lstring.h ltable.h
lstring.o: lstring.c lprefix.h lua.h luaconf.h ldebug.h lstate.h \
 lobject.h llimits.h ltm.h lzio.h lmem.h ldo.h lstring.h lgc.h
lstrlib.o: lstrlib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
ltable.o: ltable.c lprefix.h lua.h luaconf.h ldebug.h lstate.h lobject.h \
 llimits.h ltm.h lzio.h lmem.h ldo.h lgc.h lstring.h ltable.h lvm.h
ltablib.o: ltablib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
ltm.o: ltm.c lprefix.h lua.h luaconf.h ldebug.h lstate.h lobject.h \
 llimits.h ltm.h lzio.h lmem.h ldo.h lstring.h lgc.h ltable.h lvm.h
lundump.o: lundump.c lprefix.h lua.h luaconf.h ldebug.h lstate.h \
 lobject.h llimits.h ltm.h lzio.h lmem.h ldo.h lfunc.h lstring.h lgc.h \
 lundump.h
lutf8lib.o: lutf8lib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
lvm.o: lvm.c lprefix.h lua.h luaconf.h ldebug.h lstate.h lobject.h \
 llimits.h ltm.h lzio.h lmem.h ldo.h lfunc.h lgc.h lopcodes.h lstring.h \
 ltable.h lvm.h
lzio.o: lzio.c lprefix.h lua.h luaconf.h llimits.h lmem.h lstate.h \
 lobject.h ltm.h lzio.h

=== debian/changelog ===
golly (2.8-1) unstable; urgency=medium

  * New upstream.  Thanks to Dr. Tobias Quathamer.
  * debian/control (Standards-Version): conforms to 3.9.8.
  (Build-Depends): Modify to python2.7 and python2.7-dev.
  Add dh-lua.  Remove quilt.
  * debian/rules: Don't put --with quilt for dh any more.  Add lua.
  * debian/compat: Bump to 10.
  * debian/patches/0001-Build-Add-libs.patch: New.

 -- NIIBE Yutaka <gniibe@fsij.org>  Fri, 25 Nov 2016 08:34:53 +0900

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: optional
 Maintainer: NIIBE Yutaka <gniibe@fsij.org>
 Build-Conflicts: libwxgtk2.6-dev
-Build-Depends: debhelper (>= 9), autotools-dev, quilt (>= 0.46-7~), libwxgtk3.0-dev, python, python-dev, perl, libperl-dev, zlib1g-dev, dh-python
-Standards-Version: 3.9.6
+Build-Depends: debhelper (>= 10), libwxgtk3.0-dev, python-dev, python2.7, python2.7-dev, perl, libperl-dev, zlib1g-dev, dh-python, dh-lua
+Standards-Version: 3.9.8
 Homepage: http://golly.sourceforge.net/
 
 Package: golly

=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,7 @@
 export DH_OPTIONS
 
 %:
-	dh $@ --with quilt,python2 --builddirectory=build \
+	dh $@ --with python2,lua --builddirectory=build \
 	      --sourcedirectory=gui-wx/configure
 
 override_dh_auto_configure:
